﻿using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 커스텀 텍스트 박스
    /// </summary>
    public class CustomTextBox : TextBox
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// COPY 키
        /// </summary>
        private const Keys CopyKeys = Keys.Control | Keys.C;

        /// <summary>
        /// PASTE 키
        /// </summary>
        private const Keys PasteKeys = Keys.Control | Keys.V;

        /// <summary>
        /// CUT 키
        /// </summary>
        private const Keys CutKeys = Keys.Control | Keys.X;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static

        #region 명령 키 처리하기 - ProcessCmdKey(message, keyData)

        /// <summary>
        /// 명령 키 처리하기
        /// </summary>
        /// <param name="message">메시지</param>
        /// <param name="keyData">키 데이터</param>
        /// <returns>처리 결과</returns>
        protected override bool ProcessCmdKey(ref Message message, Keys keyData)
        {
            if(keyData == CopyKeys || keyData == PasteKeys || keyData == CutKeys)
            {
                return true;
            }
            else
            {
                return base.ProcessCmdKey(ref message, keyData);
            }
        } 

        #endregion
    }
}